#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "shm.h" /* zdefiniowane klucze i uprawnienia*/

int clisem, servsem; /* ident. semaforow */
int shmid[NBUFF]; // identyfikatory pamieci wspolnej
Mesg *mesgptr[NBUFF]; /*wskazniki do struktury komunikatu w segmencie pamieci wspolnej */

main()
{
register int i;
/* pobierz  dolacz segmetn pamieci wspolnej  */
for (i = 0; i< NBUFF; i++)
    {
    if ((shmid[i] = shmget(SHMKEY+i, sizeof(Mesg), 0)) < 0)
	perror("client: nie moge pobrac id segmentu pamieci ");
    if ((mesgptr[i] = (Mesg*)shmat(shmid[i], (char*)0,0)) == (Mesg*) -1)
	perror("client: nie moge dolaczyc segmentu");
    }
/* otworz dwa wczesniej utworzone semafory */
if ((clisem = sem_open(SEMKEY1)) < 0)
    perror("client: nie moge otworzyc semafora klienta");
if ((servsem = sem_open(SEMKEY2)) < 0)
    perror("client: nie moge otworzyc semafora servera");
client();
/* odlacz i usun segmenty pamieci wspolnej po czym zamknij semafory */
for (i = 0;i < NBUFF; i++)
    {
    if (shmdt(mesgptr[i]) < 0)
	perror("client: nie moge odlaczyc segmentu ");
    if (shmctl(shmid[i],IPC_RMID, (struct shmid_ds *) 0) < 0)
	perror("client: nie moge usunac segmentu");
    }
sem_close(clisem);
sem_close(servsem);
/* w ksiazce jest blad! jak skonczymy przedwczesnie to signal moze nie */
/* odniesc skutku bo system przywroci wartosc semafora wedlug wartosci */
/* nastawnej dlatego trzeba poczekac */
sleep(1);
exit(0);
}

client()
{
int i,n,all_done;
all_done = 0;
sem_wait(clisem);
if (fgets(mesgptr[0]->mesg_data, MAXMESGDATA, stdin) == NULL)
    perror("blad odczytu nazwy pliku");
n = strlen(mesgptr[0]->mesg_data);
if (mesgptr[0]->mesg_data[n-1] == '\n')
    n--;
mesgptr[0]->mesg_len = n;
sem_signal(servsem); //obodz serwer
for (;;)
    {
    for (i = 0;i<NBUFF;i++)
	{
	sem_wait(clisem); //czekaj az serwer umiesci cos w pamieci
	if (( n = mesgptr[i]->mesg_len) <= 0)
	    {
	    all_done = 1;
	    break;
	    }
	if (write (1, mesgptr[i]->mesg_data,n) != n)
	    perror("blad zapisu danych");

	sem_signal(servsem); //obodz serwer
	}
    if (all_done) break;
    }
if (n< 0)
    perror("blad odczytu danych");
}

