#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/errno.h>

extern int errno;

#include "shm.h" /* zdefiniowane klucze i uprawnienia*/

int shmid, clisem, servsem; /* pamiec wspolna oraz ident. semaforow */
Mesg *mesgptr; /*wskaznik do struktury komunikatu w segmencie pamieci wspolnej */

main()
{
 if ((shmid = shmget(SHMKEY, sizeof(Mesg), PERMS | IPC_CREAT)) < 0)
    perror("server: nie moge utworzyc segmentu");
 if ((mesgptr = (Mesg*) shmat(shmid, (char *) 0, 0)) == (Mesg *) -1)
    perror("server: nie moge dolaczyc segmentu");
 if ((clisem = sem_create(SEMKEY1, 1)) < 0)
    perror("server: nie moge utowrzyc semafora klienta");
 if ((servsem = sem_create(SEMKEY2,0)) <0)
    perror("server: nie moge utworzyc semafora servera");
 server();
 if (shmdt(mesgptr) <0)
    perror("server: nie moge odlaczyc segmentu");
 sem_close(clisem);
 sem_close(servsem);
 exit(0);
}

server()
{
int n,filefd;
char errmesg[256];
/* czekaj az klient umiesci nazwe pliku w pamieci wspolnej */
sem_wait(servsem);
/* czekamy na klienta ktory inicjuje przetwarzanie */
mesgptr->mesg_data[mesgptr->mesg_len] = '\0';
if ((filefd = open(mesgptr->mesg_data,0)) <0)
    {
/*     blad przygotuj komunikat */
    sprintf(errmesg,":nie moge otworzyc %s\n", strerror(errno));
    strcat(mesgptr->mesg_data,errmesg);
    mesgptr->mesg_len = strlen(mesgptr->mesg_data);
    sem_signal(clisem); //wyslij do klienta
    sem_wait(servsem); //czekaj az klient skonczy przetwarzanie
    }
else
    {
/*     pobieraj dane z pliku  i przesylaj klientowi */
    while ((n = read(filefd, mesgptr->mesg_data,MAXMESGDATA-1)) > 0)
	{
	mesgptr->mesg_len = n;
	sem_signal(clisem); // wyslij do klienta
	sem_wait(servsem); //czekaj az klient skonczy przetwarzac
	}
    close(filefd);
    if (n<0)
	    perror("server: blad odczytu");
    }
mesgptr->mesg_len = 0;
sem_signal(clisem);
}
