#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/errno.h>

#include "shm.h" /* zdefiniowane klucze i uprawnienia*/

int clisem, servsem,endsem; /* ident. semaforow */
int shmid[NBUFF]; // identyfikatory pamieci wspolnej
Mesg *mesgptr[NBUFF]; /*wskaznik do struktury komunikatu w segmencie pamieci wspolnej */

main()
{
 register int i;
/*  pobierz i dolacz segmenty pamieci wspolnej */
 for (i = 0; i<NBUFF; i++)
    {
    if ((shmid[i] = shmget(SHMKEY+i, sizeof(Mesg),
	PERMS | IPC_CREAT)) < 0)
	perror("server: nie moge utworzyc segmentu ");
    if ((mesgptr[i] = (Mesg*) shmat(shmid[i],(char*) 0, 0)) == (Mesg *) -1)
	perror("server: nie moge dolaczyc segmentu ");
    }
/* utworz dwa semafory */
 if ((clisem = sem_create(SEMKEY1, 1)) < 0)
    perror("server: nie moge utowrzyc semafora klienta");
 if ((servsem = sem_create(SEMKEY2,0)) <0)
    perror("server: nie moge utworzyc semafora servera");
    
 server();

 for (i = 0;i < NBUFF; i++)
    {
    if (shmdt(mesgptr[i]) <0)
    perror("server: nie moge odlaczyc segmentu ");
    }
 sem_close(clisem);
 sem_close(servsem);
/*  UWAGA !!! w ksiazce jest blad! */
/* jeeli serwer wyslal do klienta signal a zakonczy zanim klient dojdzie */
/* do wait to semafor wroci nam do wartosci nastawnych po zakonczeniu */ 
/* programu  tu trzeba poczekac lub zastosowac synchronizacje na semaforach bez SEM_UNDO */
 sleep(1); 
 exit(0);
}

server()
{
register int i,n,filefd,all_done;
char errmesg[256];
all_done = 0;
/* czekaj az klient umiesci nazwe pliku w pamieci wspolnej */
sem_wait(servsem);
/* zakocz nazw pliku znakiem pustym */
mesgptr[0]->mesg_data[mesgptr[0]->mesg_len] = '\0';
if ((filefd = open(mesgptr[0]->mesg_data,0)) <0)
    {
/*     blad przygotuj komunikat */
    sprintf(errmesg,":nie moge otworzyc %s\n", strerror(errno));
    strcat(mesgptr[0]->mesg_data,errmesg);
    mesgptr[0]->mesg_len = strlen(mesgptr[0]->mesg_data);
    sem_signal(clisem); //wyslij do klienta
    sem_wait(servsem); //czekaj az klient skonczy przetwarzanie
    mesgptr[1]->mesg_len = 0;
    sem_signal(clisem);
    }
else
    {
/*     inicjuj semserv przypisujac mu liczbe buforow */
    for (i = 0;i<NBUFF;i++)
	{
	sem_signal(servsem);
	}
/*     pobieraj dane z pliku  i przesylaj klientowi */
    for (;;)
	{
	for (i =0; i < NBUFF; i++)
	    {
	    sem_wait(servsem);
	    n = read(filefd, mesgptr[i]->mesg_data,MAXMESGDATA-1);
	    if (n<0)
		perror("server: blad odczytu");
	    mesgptr[i]->mesg_len= n;
	    sem_signal(clisem);
	    if (n==0)
	        {
	        all_done = 1;
	        break;
	        }
	    }
	if (all_done) break;
	}
    close(filefd);
    }
}
