#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "shm.h" /* zdefiniowane klucze i uprawnienia*/

int shmid, clisem, servsem; /* pamiec wspolna oraz ident. semaforow */
Mesg *mesgptr; /*wskaznik do struktury komunikatu w segmencie pamieci wspolnej */

main()
{
/* pobierz  dolacz segmetn pamieci wspolnej  */
if ((shmid = shmget(SHMKEY, sizeof(Mesg), 0)) < 0)
    perror("client: nie moge pobrac id segmentu pamieci");
if ((mesgptr = (Mesg*)shmat(shmid, (char*) 0, 0)) == (Mesg*) -1)
    perror("client: nie maoge dolaczyc segmentu");
/* otworz dwa wczesniej utworzone semafory */
if ((clisem = sem_open(SEMKEY1)) < 0)
    perror("client: nie moge otworzyc semafora klienta");
if ((servsem = sem_open(SEMKEY2)) < 0)
    perror("client: nie moge otworzyc semafora servera");
client();
if (shmdt(mesgptr) < 0)
    perror("client: nie moge odlaczyc segmentu");
if (shmctl(shmid,IPC_RMID, (struct shmid_ds *) 0) < 0)
    perror("client: nie moge usunac segmentu");
sem_close(clisem);
sem_close(servsem);
exit(0);
}

client()
{
int n;
sem_wait(clisem);
if (fgets(mesgptr->mesg_data, MAXMESGDATA, stdin) == NULL)
    perror("blad odczytu nazwy pliku");
n = strlen(mesgptr->mesg_data);
if (mesgptr->mesg_data[n-1] == '\n')
    n--;
mesgptr->mesg_len = n;
sem_signal(servsem); //obodz serwer
sem_wait(clisem); //czekaj az serwer umiesci cos w pamieci
while (( n = mesgptr->mesg_len) > 0)
    {
    if (write (1, mesgptr->mesg_data,n) != n)
	perror("blad zapisu danych");
    sem_signal(servsem); //obodz serwer
    sem_wait(clisem); //czekaj az serwer skonczy przetwarzanie
    }
if (n< 0)
    perror("blad odczytu danych");
}

